//+------------------------------------------------------------------+
//|                                                       Assert.mqh |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, TheXpert"

#include <TheXpert/DebugTools/Trace/Trace.mqh>

#define ASSERT(condition) {__TRACE_CUSTOM(assert_call) Assert(condition);}

#define ASSERT_CALLSTACK_FILENAME "AssertCallStack.txt"

void Assert(bool condition)
{
   if (!IS_DEBUG_MODE) return;

   if (!condition)
   {
      Tracer* tracer = GetTracer();
      
      CallInfo last;
      if (tracer.Last(last))
      {
         string file = last.m_File;
         uint line = last.m_Line;
         string function = last.m_Function;
         string comment = last.m_Comment;

         int res = MessageBox(" in function <" + function + ">. \n Start debugging?", "Assertion failed", MB_YESNO);
         if (res == IDYES)
         {
            tracer.SaveToFile("DebugInfo\\" + ASSERT_CALLSTACK_FILENAME);
            DebugBreak();
         }
      }
      else
      {
         // Use __TRACE macros family for having further info about assertion failure
         int res = MessageBox("No additional information available. \n Start debugging?", "Assertion failed", MB_YESNO);
         if (res == IDYES)
         {
            tracer.SaveToFile("DebugInfo\\" + ASSERT_CALLSTACK_FILENAME);
            DebugBreak();
         }
      }
   }
}