//+------------------------------------------------------------------+
//|                                                FileUnlimited.mqh |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"

#include <TheXpert/FileUnlimited/Interfaces.mqh>

// dll import
#import "kernel32.dll"
   int    CopyFileW(string lpExistingFileName, string lpNewFileName, int bFailIfExists);
   int    DeleteFileW (string lpFileName);
   int    MoveFileW (string lpExistingFileName, string lpNewFileName);
   uint   GetLastError(int);

// libraries
#import "TheXpert/FileUnlimited/ConstFileUnlimited.ex5"
   ConstFile* OpenConstFile(string path);
#import "TheXpert/FileUnlimited/ConstFileUnlimitedWide.ex5"
   ConstFileWide* OpenConstFileWide(string path);
#import "TheXpert/FileUnlimited/FileUnlimited.ex5"
   File* OpenFile(string path, CreationDisposition options, DesiredAccess access);
#import "TheXpert/FileUnlimited/FileUnlimitedWide.ex5"
   FileWide* OpenFileWide(string path, CreationDisposition options, DesiredAccess access);
#import

uint GetLastErrorWin()
{
   return GetLastError(0);
}

bool CopyFile(string from, string to, bool failIfExists = false)
{
   return CopyFileW(from, to, int(failIfExists)) != 0;
}

bool DeleteFile(string what)
{
   return DeleteFileW(what) != 0;
}

bool MoveFile(string from, string to)
{
   return MoveFileW(from, to) != 0;
}