//+------------------------------------------------------------------+
//|                                       FileUnlimitedConstants.mqh |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"

//====    "CreateFile()".
// ----  "dwDesiredAccess".
#define FU_GENERIC_WRITE                0x40000000 //     .
#define FU_GENERIC_READ                 0x80000000 //     .

// ----  "dwShareMode".
#define FU_FILE_SHARE_NO                0x00000000 //    .
#define FU_FILE_SHARE_READ              0x00000001 //          .
#define FU_FILE_SHARE_WRITE             0x00000002 //          .
#define FU_FILE_SHARE_DELETE            0x00000004 //          . 

// ----  "dwCreationDisposition".
#define FU_CREATE_NEW                   1          //   ,    .
#define FU_CREATE_ALWAYS                2          //   , .
#define FU_OPEN_EXISTING                3          //    ,   .
#define FU_OPEN_ALWAYS                  4          //  , .
#define FU_TRUNCATE_EXISTING            5          //        -  ,    .

//====    "SetFilePointer()".
#define FU_FILE_BEGIN                   0          //   .
#define FU_FILE_CURRENT                 1          //   .
#define FU_FILE_END                     2          //   .

#define INVALID_SET_FILE_POINTER (uint(-1))
#define INVALID_FILE_ATTRIBUTES (uint(-1))

enum DesiredAccess
{
	  DA_READ_WRITE = FU_GENERIC_READ | FU_GENERIC_WRITE
	, DA_WRITE = FU_GENERIC_WRITE
};

enum CreationDisposition
{
	  CD_CREATE_NEW = FU_CREATE_NEW                 // always create new file
	, CD_CREATE_ALWAYS = FU_CREATE_ALWAYS           // create if does not exist, or open without errors
	, CD_OPEN_EXISTING = FU_OPEN_EXISTING           // will fail if file does not exist
	, CD_OPEN_ALWAYS = FU_OPEN_ALWAYS               // create if does not exist, or open with error ERROR_ALREADY_EXISTS (80)
	, CD_TRUNCATE_EXISTING = FU_TRUNCATE_EXISTING   // will fail if file does not exist or truncate it if exists
};

enum MovePointerMethod
{
	  MPM_BEGIN = FU_FILE_BEGIN            // relative count from the beginning
	, MPM_CURRENT = FU_FILE_CURRENT        // relative count from current
	, MPM_END = FU_FILE_END                // relative count from the end
};

