//+------------------------------------------------------------------+
//|                                            FileUnlimitedTest.mq5 |
//+------------------------------------------------------------------+
#property copyright "TheXpert"

#include <TheXpert/FileUnlimited/Interfaces.mqh>
#include <TheXpert/StringUtils.mqh>

#include <TheXpert/DebugTools/ASSERT.mqh>
#include <TheXpert/DebugTools/Trace/Trace.mqh>


void OnStart()
{__TRACE
   string name = "TheXpert\\Test.txt";
   string path = TerminalInfoString(TERMINAL_DATA_PATH) + "\\MQL5\\Files\\" + name;
   
   bool b1 = false, b2 = true;
   int i1 = -14, i2 = 243978;
   double d1 = -4.345, d2 = 248.234234;
   color c1 = clrBlueViolet, c2 = clrBlack;
   datetime t1 = TimeCurrent(), t2 = D'1990.10.5';
   string s1 = "1", s2 = "2348962349876";

   {
      File* file = OpenFile(path, CD_CREATE_ALWAYS, DA_READ_WRITE);
      if (CheckPointer(file) != POINTER_INVALID)
      {
         ASSERT(file.Write(b1));
         ASSERT(file.Write(long(i1)));
         ASSERT(file.Write(d1));
         ASSERT(file.Write(c1));
         ASSERT(file.Write(t1));
         ASSERT(file.Write(s1));
         ASSERT(file.Write(b2));
         ASSERT(file.Write(long(i2)));
         ASSERT(file.Write(d2));
         ASSERT(file.Write(c2));
         ASSERT(file.Write(t2));
         ASSERT(file.Write(s2));
         
         delete file;
      }
      else
      {
         Print("OpenFile failed with error #", GetLastErrorWin());
         ASSERT(false);
      }
   }

   bool b1_ = true, b2_ = false;
   int i1_ = 0, i2_ = 0;
   double d1_ = 0, d2_ = 0;
   color c1_ = clrBlack, c2_ = clrBlack;
   datetime t1_ = 0, t2_ = 0;
   string s1_ = "", s2_ = "";
   
   {
      ConstFile* file = OpenConstFile(path);
      if (CheckPointer(file) != POINTER_INVALID)
      {
         ASSERT(file.Read(b1_));
         ASSERT(file.Read(i1_));
         ASSERT(file.Read(d1_));
         ASSERT(file.Read(c1_));
         ASSERT(file.Read(t1_, ";\t\n\r"));
         ASSERT(file.Read(s1_));
         ASSERT(file.Read(b2_));
         ASSERT(file.Read(i2_));
         ASSERT(file.Read(d2_));
         ASSERT(file.Read(c2_));
         ASSERT(file.Read(t2_, ";\t\n\r"));
         ASSERT(file.Read(s2_));
         
         delete file;
      }
      else ASSERT(false);
   }
   
   ASSERT(b1 == b1_);
   ASSERT(i1 == i1_);
   ASSERT(d1 == d1_);
   ASSERT(c1 == c1_);
   ASSERT(t1 == t1_);
   ASSERT(s1 == s1_);
   ASSERT(b2 == b2_);
   ASSERT(i2 == i2_);
   ASSERT(d2 == d2_);
   ASSERT(c2 == c2_);
   ASSERT(t2 == t2_);
   ASSERT(s2 == s2_);
}